package org.infinispan.xsite.irac;

import java.util.Arrays;
import java.util.Collections;
import javax.annotation.Generated;

import org.infinispan.factories.impl.ComponentAccessor;
import org.infinispan.factories.impl.ModuleMetadataBuilder;
import org.infinispan.factories.impl.MBeanMetadata;
import org.infinispan.factories.impl.MBeanMetadata.AttributeMetadata;
import org.infinispan.factories.impl.MBeanMetadata.OperationMetadata;
import org.infinispan.factories.impl.MBeanMetadata.OperationParameterMetadata;
import org.infinispan.factories.impl.WireContext;
import org.infinispan.lifecycle.ModuleLifecycle;

/**
 * @private 
 */
@Generated(value = "org.infinispan.component.processor.Generator", date = "2022-01-27T09:35:17.722684Z")
public final class CorePackageImpl {
   public static void registerMetadata(ModuleMetadataBuilder.ModuleBuilder builder) {
//start org.infinispan.xsite.irac.IracManager
      builder.registerComponentAccessor("org.infinispan.xsite.irac.IracManager",
         Collections.emptyList(),
         new ComponentAccessor<IracManager>("org.infinispan.xsite.irac.IracManager",
            1, false, null,
            Collections.emptyList()));

//start org.infinispan.xsite.irac.NoOpIracManager
      builder.registerComponentAccessor("org.infinispan.xsite.irac.NoOpIracManager",
         Collections.emptyList(),
         new ComponentAccessor<NoOpIracManager>("org.infinispan.xsite.irac.NoOpIracManager",
            1, false, null,
            Collections.emptyList()));

//start org.infinispan.xsite.irac.DefaultIracManager
      builder.registerComponentAccessor("org.infinispan.xsite.irac.DefaultIracManager",
         Collections.emptyList(),
         new ComponentAccessor<DefaultIracManager>("org.infinispan.xsite.irac.DefaultIracManager",
            1, false, null,
            Arrays.asList("org.infinispan.remoting.rpc.RpcManager", "org.infinispan.xsite.status.TakeOfflineManager", "org.infinispan.interceptors.locking.ClusteringDependentLogic", "org.infinispan.commands.CommandsFactory", "org.infinispan.container.versioning.irac.IracVersionGenerator", "org.infinispan.container.versioning.irac.IracTombstoneManager", "org.infinispan.executors.timeout", "org.infinispan.executors.blocking")) {
         protected void wire(DefaultIracManager instance, WireContext context, boolean start) {
            instance.rpcManager = context.get("org.infinispan.remoting.rpc.RpcManager", org.infinispan.remoting.rpc.RpcManager.class, start);
            instance.takeOfflineManager = context.get("org.infinispan.xsite.status.TakeOfflineManager", org.infinispan.xsite.status.TakeOfflineManager.class, start);
            instance.clusteringDependentLogic = context.get("org.infinispan.interceptors.locking.ClusteringDependentLogic", org.infinispan.interceptors.locking.ClusteringDependentLogic.class, start);
            instance.commandsFactory = context.get("org.infinispan.commands.CommandsFactory", org.infinispan.commands.CommandsFactory.class, start);
            instance.iracVersionGenerator = context.get("org.infinispan.container.versioning.irac.IracVersionGenerator", org.infinispan.container.versioning.irac.IracVersionGenerator.class, start);
            instance.iracTombstoneManager = context.get("org.infinispan.container.versioning.irac.IracTombstoneManager", org.infinispan.container.versioning.irac.IracTombstoneManager.class, start);
            instance.inject(
               context.get("org.infinispan.executors.timeout", java.util.concurrent.ScheduledExecutorService.class, start),
               context.get("org.infinispan.executors.blocking", java.util.concurrent.Executor.class, start)
            );
         }

         protected void start(DefaultIracManager instance) throws Exception {
            instance.start();
         }

      });

      builder.registerMBeanMetadata("org.infinispan.xsite.irac.DefaultIracManager",
         MBeanMetadata.of("AsyncXSiteStatistics", "Statistics for Asynchronous cross-site replication", null,
            new AttributeMetadata("queueSize", "Number of keys that need to be sent to remote site(s)", false, true, "int", false, (java.util.function.Function<org.infinispan.xsite.irac.DefaultIracManager, ?>) org.infinispan.xsite.irac.DefaultIracManager::getQueueSize, null),
            new AttributeMetadata("numberOfTombstones", "Number of tombstones stored", false, true, "int", false, (java.util.function.Function<org.infinispan.xsite.irac.DefaultIracManager, ?>) org.infinispan.xsite.irac.DefaultIracManager::getNumberOfTombstones, null),
            new AttributeMetadata("numberOfConflicts", "The total number of conflicts between local and remote sites.", false, true, "long", false, (java.util.function.Function<org.infinispan.xsite.irac.DefaultIracManager, ?>) org.infinispan.xsite.irac.DefaultIracManager::getNumberOfConflicts, null),
            new AttributeMetadata("numberOfDiscards", "The number of updates from remote sites discarded (duplicate or old update).", false, true, "long", false, (java.util.function.Function<org.infinispan.xsite.irac.DefaultIracManager, ?>) org.infinispan.xsite.irac.DefaultIracManager::getNumberOfDiscards, null),
            new AttributeMetadata("numberOfConflictsLocalWins", "The number of conflicts where the merge policy discards the remote update.", false, true, "long", false, (java.util.function.Function<org.infinispan.xsite.irac.DefaultIracManager, ?>) org.infinispan.xsite.irac.DefaultIracManager::getNumberOfConflictsLocalWins, null),
            new AttributeMetadata("numberOfConflictsRemoteWins", "The number of conflicts where the merge policy applies the remote update.", false, true, "long", false, (java.util.function.Function<org.infinispan.xsite.irac.DefaultIracManager, ?>) org.infinispan.xsite.irac.DefaultIracManager::getNumberOfConflictsRemoteWins, null),
            new AttributeMetadata("numberOfConflictsMerged", "Number of conflicts where the merge policy created a new entry.", false, true, "long", false, (java.util.function.Function<org.infinispan.xsite.irac.DefaultIracManager, ?>) org.infinispan.xsite.irac.DefaultIracManager::getNumberOfConflictsMerged, null),
            new AttributeMetadata("statisticsEnabled", "Enables or disables the gathering of statistics by this component", true, true, "boolean", false, null, null),
            new OperationMetadata("resetStatistics", "", "Resets statistics gathered by this component", "void"
            )
      ));

//end
   }
}
